local rev = tonumber(("$Revision: 180 $"):match("(%d+)")) or 0
if rev > GuildCraft.version then GuildCraft.version = rev end

local D
do
	function D(...)
		local str
		local arg = select(1, ...) or ""
		if string.find(arg, "%%") then
			str = (select(1, ...)):format(select(2,...))
		else
			str = string.join(", ", tostringall(...))
			str:gsub(":,", ":")
		end
		if (not GuildCraft ) or (not GuildCraft.db.global.debug.comms) then
			return str
		end

		ChatFrame1:AddMessage("|cff33FF66GC~WotLK-ChatComms:|r: "..str)
	end
end


--[[  HOUSEKEEPING  ]]--
local addonParent = LibStub("AceAddon-3.0"):GetAddon("GuildCraft")
local module = addonParent:NewModule("CommsIO", "AceComm-3.0", "AceSerializer-3.0")
module.rev = rev
local self_player = UnitName("player")
local Addon_Prefix = "GuildCraft3"
module.cbh = LibStub("CallbackHandler-1.0"):New(module, "RegisterCommsCall", "UnregisterCommsCall")

function module:OnEnable()
	self:RegisterComm(Addon_Prefix)
	D("Communications Module Loaded")
end

local function DispatchComms(sender, result, command, ...)
	if not result then return end
	D("Dispatching Comms Command %s, from %s", command, sender)
	module.cbh:Fire(command, sender, ...)
end
module.DispatchComms = DispatchComms

function module:OnCommReceived(prefix, message, distribution, sender)
	if prefix ~= Addon_Prefix then return end
	DispatchComms(sender, self:Deserialize(message))
end

local function Cerial(...)
	return module:Serialize(...)
end

--[[  Support Calls & Outbound Communications  ]]--


function module:SendToGuild(...)
	if IsInGuild() then
		D("Sending To Guild:", ... )
		module:SendCommMessage(Addon_Prefix, Cerial(...), "GUILD", nil, "BULK")
	end
end

function module:SendWhisper(player, ...)
	D("Sending Whisper to:", player, "Command:", ... )
	module:SendCommMessage(Addon_Prefix, Cerial(...), "WHISPER", player, "BULK")
end

local embeds = {
	"SendToGuild",
	"SendWhisper",
	"RegisterCommsCall", 
	"UnregisterCommsCall"
}

function module:SoftEmbed(target)
	for i,v in ipairs(embeds) do
		target[v] = module[v]
	end
end
