local rev = tonumber(("$Revision: 215 $"):match("(%d+)")) or 0
if rev > GuildCraft.version then GuildCraft.version = rev end

local D, newTable, delTable, clearTable, newList, newDict, clearAndFillTableList

do
	function D(...)
		local str
		local arg = select(1, ...) or ""
		if string.find(arg, "%%") then
			str = (select(1, ...)):format(select(2,...))
		else
			str = string.join(", ", tostringall(...))
		end
		str = str:gsub(":,", ":")
		if GuildCraft and GuildCraft.db.global.debug.dbo then
			ChatFrame1:AddMessage("|cff33FF66GC~WotLK-DBO:|r "..str)
		end
		return str
	end
end

do
-- Table Pool for recycling tables
	local tablePool = {}
	setmetatable(tablePool, {__mode = "kv"});	-- Weak table

	function newTable()
		local t = next(tablePool) or {};
		tablePool[t] = nil;
		return t;
	end

	function delTable(t)
		if (type(t) == "table") then
			for k, v in pairs(t) do
				if (type(v) == "table") then
					delTable(v);	-- child tables get put into the pool
				end
				t[k] = nil;
			end
			setmetatable(t, nil);
			t[true] = true;
			t[true] = nil;
			tablePool[t] = true;
		end
		return nil;
	end
	
	function clearTable(t)
		for k,v in pairs(t) do
			if type(v) == 'table' then
				t[k] = delTable(t[k])
			else
				t[k] = nil
			end
		end
		return t
	end
	function newList(...)
		local t = newTable()
		for i = 1, select("#", ...) do
			t[i] = select(i, ...)
		end
		return t
	end
	function newDict(...)
		local t = newTable()
		for i = 1, select("#", ...), 2 do
			t[(select(i,...))] = select(i + 1, ...)
		end
		return t
	end
	function clearAndFillTableList(t, ...)
		t = clearTable(t)
		for i = 1, select("#", ...) do
			t[i] = select(i, ...)
		end
		return t
	end
end

--[[  HOUSEKEEPING  ]]--
local AddonParent = LibStub("AceAddon-3.0"):GetAddon("GuildCraft")
local module = AddonParent:NewModule("DBO")
module.rev = rev
local CommsIO, TradeSkillScanner, player_name
local L = LibStub("AceLocale-3.0"):GetLocale("GuildCraft")
--local L = AddonParent.L
local BTS = LibStub("Mini-Bable-TradeSkill")
local LTL = LibStub("TradeLinkDecoder-1.0")
local LibAlts = LibStub("LibAlts-1.0", true)
local fr, cache, GuildTrades, main, cacheIsInit, optionsDBO
module.D = D
function module:OnEnable()
	fr = AddonParent.db.factionrealm	--Faction Realm Data table to put links into
	cache = AddonParent.Cache		--cache table stuff
	GuildTrades = cache.GuildTrades		--
	main = cache.main			--

	player_name = UnitName("player")

	AddonParent:GetModule("CommsIO"):SoftEmbed(self)		--To Embed
	TradeSkillScanner = AddonParent:GetModule("TradeSkillScanner")	-- for references
	--Comms Stuff
	self:RegisterCommsCall("Update_Live_Player_Data")
	self:RegisterCommsCall("Call_For_Update")
	self:RegisterCommsCall("AddonVersion")
	--self:RegisterCommsCall("HasOfflineData")	--This has been disabled as of 3.1.8, till i can find a better way.
	--self:RegisterCommsCall("CheckOfflineData")	--This has been disabled as of 3.1.8, till i can find a better way.
	self:RegisterCommsCall("DBO_Func_GetData")
	self:RegisterCommsCall("DBO_Func_UpdateRemoteData")
	
	--self:RegisterCommsCall("")

	self:InitComms()
	--self:InitOfflineSynch()
	LibAlts = LibStub("LibAlts-1.0", true)
	D("DBO LOADED")
end

function module:InitComms()
	self:SendToGuild("Call_For_Update")
end

function module:PublishToGuild(event, sender, ...)
	D(event or "Publishing to Guild")
	if AddonParent.db.char.shareToGuild then
		self:SendToGuild("Update_Live_Player_Data", TradeSkillScanner:ScanTradeSkills() )
	end
	if AddonParent.db.char.shareToChat and AddonParent:GetModule("ChatChannelComms", true) then
		AddonParent:GetModule("ChatChannelComms"):SendChatMessage("Update_Live_Player_Data", TradeSkillScanner:ScanTradeSkills() )
	end
		
	self:SendToGuild("AddonVersion", AddonParent.version)
end
module.Call_For_Update = module.PublishToGuild

--	"SendToGuild",	"SendWhisper",	"RegisterCommsCall", 	"UnregisterCommsCall"
--[[
Plan:
 On Enable send off info in this fasion
 "Update Trade Skill", |Link1|, |Link2|, ...
 then let receving client figure it out from there.
]]--
	local tradeLink_Regex = "trade:%d+:%d+:%d+:[0-9a-fA-F]+:([A-Za-z0-9+/]+)"
local function compareLinks(l1, l2)	--l1 is the local link, l2 is the remote link
	D("Comparing Links", l1, l2)
	-- function designed to where l1 is the local list and l2 is the incoming data. 
	-- if incomming data dosn't match local then return true as there is something to do.
	if l1 == l2 then
		D("CL: links are same returning false")
		return false
	end
	local s1, s2 = l1:match(tradeLink_Regex) or "", l2:match(tradeLink_Regex) or ""
	if s1 == s2 then
		D("CL: tradeData is same")
		return false
	end
	if s2 > s1 then
		D("CL: s2 > s1, returning true")
		return true
	end
	D("All else failed, decoding links and doing a table compare")
	local t1, t2 = LTL:Decode(l1, true, true), LTL:Decode(l2, true, true)
	if (not t1) or (not t2) then
		local m = "Please go Update Guild Craft.\n Error LibTradeLinks is Out of Date"
		message(m)
		geterrorhandler()(m.."\n"..debugstack())
		return
	end
	for k, _ in pairs(t2) do
		if not t1[k] then
			D("%s not found in old data, we got new link", k)
			return true
		end
	end
	D("Didn't find new data, we return nil here")	--If this happens then 3 compares have FAILED... and something else should have errord.
	return nil
end

function module:Update_Live_Player_Data(event, sender, ...)				--Workhorse of the Synch, we use alot....
	D("~ULPD:", event, "Sender:", sender, "Data:", ...)
	local t = fr.links[sender] or newTable()					--Get Existing data or work with new table..
	local str, updated = ""		--string used later
	for i = 1, select("#", ...)  do
		local link = select(i, ...)
		local professionID = link:match("trade:(%d+):");			--we don't send english name anymore, just grab the id
		if not professionID then return end					--ok so this link is BS if this evaluates
		local eName = BTS:ReverseTranslate( (GetSpellInfo(professionID)) )	--get english name, makes things easier to debug..
		if not eName then
			error( D("Bad English Name", event, sender, eName, professionID, link) )
		end	
		str = str..";"..eName							--add the english name to string, used later..
		if t[eName] then							--ok we have this link before
			if compareLinks(t[eName], link) then				--compare the 2, if arg2 is something better we update.
				D("Updating link for %s, for %s", eName, sender)
				t[eName] = link
				cacheIsInit, updated = false, true			--Tell the cache that they are not init, b/c we have new data, tell loop we have new data too
			end
		else									--never seen this link for this player... add it..
			D("%s's data not found for %s, adding", sender, eName)
			t[eName] = link
			cacheIsInit, updated = false, true
		end
	end

	if event ~= "Trade_Window_Open" then
		D("event not T_W_O")
		D(" -Checking for errant tradeskills for %s", sender)
		D("current ts string:", str)
		for k in pairs(t) do
			D("checking", k)
			if not str:find(k) then							--we check the english name agent the ";" seperated list.. if we got something there that wasn't before
				D(" -Errant Trade Skill found, %s, removing", k)
				t[k] = nil							--nix it, this allows for people to change professions with out the guild needing to reset the database.
			end
		end
	end

	if updated then
		self:Print(L["%s' tradeskill data updated"], sender)
	end
	fr.links[sender] = t
	--D(event, "ended, cache table will be init on API use and if updates happen mid stream then it will also be updated.")
	--self:UpdateCacheDataForPlayer(sender, ...)
end

local function AlphaSort(...)
	local t = newTable()
	for i = 1, select("#", ...) do
		local obj = select(i, ...):trim()
		if obj ~= "" then
			tinsert(t, obj)
		end
	end
	table.sort(t)
	local str = table.concat(t, ", ")
	t = delTable(t)
	return str
end

function module:UpdateCacheTable(clearFirst)
	--D("~Update Cache Table~")		
	cache = AddonParent.Cache	--just sanity checks...
	if clearFirst then
		cache.main = clearTable(cache.main)
		cache.GuildTrades = clearTable(cache.GuildTrades)
	end

	GuildTrades = cache.GuildTrades
	main = cache.main

	if LTL:GetBuildVersion() ~= select(2, GetBuildInfo() ) then
		message("Please Update Guild Craft,\n Data Did not load")
		return
	end

	for name, data in pairs(fr.links) do		--Pair though the main table...
		--D("Update All: for player %s", name)	--pair though player table..
		for eName, link in pairs(data) do
			--D("Update All: sending off %s, for %s", eName, name)	--we do this because we already have something that updates individual info
			self:UpdateCacheDataForPlayer(name, eName, link)	--so just call it with limited data..
		end
	end
	cacheIsInit = true	--tell the Public API we're ready...
	--local b = AddonParent:GetModule("BrowserUI", true)	--Don't do this anymore becuse we got a refresh button
	--if b then
		--b:InitValues()		--cross link the browser and update some stuff..
		--D("Tell browser to update, sorta")
	--end
end

function module:UpdateCacheDataForPlayer(name, eName, link)
	D("~Updating specific data for:", name, eName, link)
	--D(eName, link)		--sanity check..
	local tradeSpellList = LTL:Decode(link, true, true)					--decode the link
	if not tradeSpellList then								--sometimes the link dosn't decode b/c our lib is out of date..
		D("Link %s didn't decode", link)		
		return
	end
	D("Working with player, %s, trade: %s", name, eName)
	local tData = main[eName] or newTable()							--Get our database info, or create a new container.
	for k, _ in pairs(tradeSpellList) do							--itterate though the decoded tradeskill list
		k = tostring(k)									--we use key's here traditionaly as strings, atleast that's what the browser is expecting
		local entry = tData[k]								--if we existed before get our craft'ers list 
		if entry then
			if not entry:find(name) then						--easy upgrade mode, search feild for our name..
				entry = entry..","..name 					--add name, we sort the list later.
			end
		else										--we have absoultly nothing on this item, it's new.. add ourselves as first one..
			entry = name
		end
		tData[k] = entry								--easy upgrade model, re associate the craft'ers list with the item.
	end											--do this for everything...
	main[eName] = tData									--associate the tradeskill info to the cache table, easy upgrade
	local gtE = GuildTrades[eName] or ""
	if not gtE:find(name) then
		gtE = string.join(",", gtE, name)
	else
		gtE = name
	end
	GuildTrades[eName] = gtE
end


local Color_AltAssociate
do
	local online, offline = AddonParent.online, AddonParent.offline
	local function color(name)
		if type(name) ~= "string" or name == "" then return v end
		if online[name] then
			return string.join("", "|cff1eff00", name, "|r")
		elseif offline[name] then
			return string.join("", "|cff9d9d9d", name, "|r")
		else
			return string.join("", "|cffff7f3f", name, "|r")
		end
	end
	local function validateFunc(v) return v:upper() end
	local trashTable = {}
	function Color_AltAssociate(...)
		local t = wipe(trashTable)
		for i = 1, select("#", ...) do
			local obj = select(i, ...):trim()
			if obj ~= "" then
				tinsert(t, obj)
			end
		end
		table.sort(t)
		if LibAlts then
			for i,v in pairs(t) do
				local main = LibAlts:GetMain(v)
				if main then
					main = color( main:lower():gsub("^%a", validateFunc) )
					t[i] = string.join("", color(v), " (", main, ")")
				else
					t[i] = color(v)
				end
			end

		else
			for i,v in ipairs(t) do
				t[i] = color(v)
			end
		end

		local str = table.concat(t, ", ")
		return str
	end
end
module.Color_AltAssociate = Color_AltAssociate


---Public API-- oddly enough inside a module...

function module:GetGuildTradesList()		--This returns a dictionary table where the english tradeskill is the name.
	if not cacheIsInit then
		self:UpdateCacheTable()
	end
	return GuildTrades
end

function module:GetCraftersForTrade(skill)
	if not cacheIsInit then
		self:UpdateCacheTable()
	end
	
	return GuildTrades[skill] and Color_AltAssociate( (","):split(GuildTrades[skill]))
end

function module:GetMakersByMain_Alt(skill, value)	--do not hook this for alt associate, use LibAlts
	if not cacheIsInit then			
		self:UpdateCacheTable()
	end
	if main[skill] and main[skill][value] then
		local sucsess, string = pcall(Color_AltAssociate,  (","):split(main[skill][value] ) )
		return sucsess and string or main[skill][value]
	else
		return ""
	end
end

function module:GetGuildTrade(skill)		--Flat Call for the entire tradeskill table, returns in format of item being the key and who can make it being the value
	if not cacheIsInit then			--do not alter the data returned w/ this function or i'll start CopyTabl'ing it out..
		self:UpdateCacheTable()
	end

	return main[skill] and main[skill] or nil
end


---End Public Api

function module:AddonVersion(event, sender, version)
	AddonParent.db.global.playerVersions[sender] = version
end

---Offline Synch...
--There are a few problems with this idea of waiting about 10 seconds..
-- we create a psudo race condition, if person A changes professions, and updates player B then player A logs out.
-- player C logs in and has old data, this will cause player C to reUpdate player B with old data...
-- to prevent this, we don't talk to ourselfs in an offline check.. so that others can update us.
-- this can become problatic if people start to cascade on each other..
-- if this becomes a problem, it will fall back on the 3rd party push/pull-private/guild mechinisum. Oh that could get fucky fast..

--This has been disabled as of 3.1.8, till i can find a better way.

function module:InitOfflineSynch()
	self:SendToGuild("CheckOfflineData")
end

function module:CheckOfflineData(event, sender, ...)
	D(event, "Sender:", sender, ...)
	if sender == player_name then
		D(event, "We don't talk to ourselfs in an offline check")
		return
	end
	if not AddonParent.hasUpdateRoster then 
		D("**No Roster Data on %s", event)
		return
	end
	local t = nil	
	for k, _ in pairs(AddonParent.offline) do
		if fr.links[k] then
			D("%s data found and player is offline", k)
			t = t or newTable()
			tinsert(t, k)
			for _,v in pairs(fr.links[k]) do
				D("Adding %s to list", v)
				tinsert(t, v)
			end
		end
	end
	D("Have offline data", (type(t) == "table" and unpack(t) or "no offline data"))
	if (type(t) == "table" and next(t)) then
		self:SendToGuild("HasOfflineData", unpack(t))
		
	end
	self:CancelTimer(offlineTimmer, true)
	delTable(t)
end

function module:HasOfflineData(event, sender, ...)
	D("~HOD:", event ,"Sender/Reqest:", sender, "Data:", ...)
	if (event == "HasOfflineData" and sender == player_name) then
		D(event, "We don't talk to ourselfs in an offline check")
		return
	end
	--if not AddonParent.hasUpdateRoster then 
	--	D("no Roster Data on offline dataCheck")
	--	return
	--end
	local name, linksList = (select(1, ...)), newTable()
	if name:find("|") then
		self:Print(L["Bad Offline data from %s, tell them to update or reset their DB"], sender)
		return
	end
	local numArgs = select("#", ...)
	for i = 2, numArgs do
		local obj = select(i, ...)
		if name and obj:find("|") then 	--if we have a name and the obj has a | in it then this is a link
			tinsert(linksList, obj)	--add link to list.
			if i == numArgs then	--if our index is equal to the # of args, then we are at the end, publish.
				self:Update_Live_Player_Data(event, name, unpack(linksList))
			end
		elseif name and (not obj:find("|") ) then		--if we have a name, and the object dosn't have a | in it, then we have a new name and list.
			self:Update_Live_Player_Data(event, name, unpack(linksList))	--publish current data
			clearTable(linksList)		--clear links table
			name = obj		-- set the new name to the object as we are starting that list over again now..
		end		
	end
end

---3rd party data pull function

function module:DBO_Func_GetData(event, sender, data)
	D(event, "Request From:", sender, "For:", data)
	if fr.links[data] and (AddonParent.online[data] or AddonParent.offline[data]) then
		D("We have data for %s, compiling and sending", data)
		local t = newTable()
		for _, v in pairs(fr.links[data]) do
			tinsert(t, v)
		end
		self:SendWhisper(sender, "DBO_Func_UpdateRemoteData", data, unpack(t))
		t = delTable(t)
	end
end

module.DBO_Func_UpdateRemoteData = module.HasOfflineData
