--ChoicesUI
local rev = tonumber(("$Revision: 203 $"):match("(%d+)")) or 0
if rev > GuildCraft.version then GuildCraft.version = rev end

--GenericDebugFunc
local D
do
	function D(...)
		local str
		local arg = select(1, ...) or ""
		if string.find(arg, "%%") then
			str = (select(1, ...)):format(select(2,...))
		else
			str = string.join(", ", tostringall(...))
			str:gsub(":,", ":")
		end
		if (not GuildCraft ) or (not GuildCraft.db.global.debug.fubar) then
			return str
		end

		ChatFrame1:AddMessage("|cff33FF66GC~WotLK-Broker:|r: "..str)
	end
end

local AddonParent = LibStub("AceAddon-3.0"):GetAddon("GuildCraft")
local module = AddonParent:NewModule("BrokerModule")
module.rev = rev
local L = LibStub("AceLocale-3.0"):GetLocale("GuildCraft")
--local L = AddonParent.L
local BTS = LibStub("Mini-Bable-TradeSkill")

--local default_options = {
--	profile = {
--		["showExtTT"] = true,
--	},
--}

function module:OnEnable()	
	--module.db = AddonParent.db:RegisterNamespace("FuBarOptions", default_options)
	
--Register LDB Stuff
	LibStub("LibDataBroker-1.1"):NewDataObject("GuildCraft", {
		type = "launcher",
		label = "GuildCraft",
		text = "GuildCraft",
		icon = "Interface\\Icons\\Ability_Repair",
		OnClick = function(frame, msg)
			if msg == "RightButton" then
				if LibStub("AceConfigDialog-3.0").OpenFrames["Guild Craft"] then
					LibStub("AceConfigDialog-3.0"):Close("Guild Craft")
				else
					LibStub("AceConfigDialog-3.0"):Open("Guild Craft")
				end
			else
				local error, msg = pcall(AddonParent.initBrowser)
				if not error then
					module:Print("Cannot Open Browser. Reason: %s", msg)
				end
			end
		end,
		OnTooltipShow = module.OnTooltip,
		hasAce3Options = "Guild Craft",	--Application name
		
	})

	D("LDB Module Loaded")
end


do	--Basic Tooltip
	local trashTable = {}
	local dbo = AddonParent:GetModule("DBO", true)
	function module.OnTooltip(tooltip)
		D("OnTooltip")
		tooltip = tooltip or GameTooltip
		if not tooltip or not tooltip.AddLine then return end
		tooltip:AddLine(L["Guild Craft"])
		tooltip:AddLine("|cffffff00" .. L["Click|r to toggle the Browser"])
		tooltip:AddLine("|cffffff00" .. L["Right-click|r to open the options menu"])

		if AddonParent.db and AddonParent.db.profile.ShowExtTT and dbo and (next(AddonParent.Cache.GuildTrades)) then
			tooltip:AddLine(" ")
			wipe(trashTable)
			local gTrade = AddonParent.Cache.GuildTrades
			for trade,_ in pairs(gTrade) do
				tinsert(trashTable, trade)
			end
			table.sort(trashTable)
			for i,v in pairs(trashTable) do
				if v ~= "Cooking" then
					tooltip:AddDoubleLine(v, nil)
					tooltip:AddLine( "     "..dbo.Color_AltAssociate(string.split(",",gTrade[v])))
				end
			end
			tooltip:AddLine(" ")
			tooltip:AddLine(("|cff1eff00%s|r, |cff9d9d9d%s|r, |cffff7f3f%s|r"):format(GUILD_ONLINE_LABEL, PLAYER_OFFLINE, L["Not In Guild"] ))
			tooltip:Show()
		end				
	end

end


do 
	return
end
do	--Extended Tooltip
	local nameIndex = {}
	function module.OnTooltip(tooltip)
		D("OnTooltip")
		tooltip = tooltip or GameTooltip
		if not tooltip or not tooltip.AddLine then return end
		tooltip:AddLine(L["Guild Craft"])
		tooltip:AddLine("|cffffff00" .. L["Click|r to toggle the Browser"])
		tooltip:AddLine("|cffffff00" .. L["Right-click|r to open the options menu"])
		if AddonParent.db and AddonParent.db.profile.ShowExtTT then
			for i=1,#nameIndex do nameIndex[i] = nil end

			tooltip:AddLine(" ")
			local links, addonVersion, gTrade = AddonParent.db.factionrealm.links, AddonParent.db.global.playerVersions, AddonParent.Cache.GuildTrades
			for player,_ in pairs(links) do
				tinsert(nameIndex, player)
			end
			table.sort(nameIndex)
			for i,v in ipairs(nameIndex) do
				if addonVersion[v] then
					--D("Add Tooltip line: %s, %s", (v or "?"), (addonVersion[v] or "?") )
					tooltip:AddDoubleLine( (v or "") , (addonVersion[v] or "") )
				end
			end
			for i=1,#nameIndex do nameIndex[i] = nil end
	
			if type(gTrade) == "table" and next(gTrade) then
				for k,_ in pairs(gTrade) do tinsert(nameIndex, k) end
				table.sort(nameIndex)
				tooltip:AddLine(" ")
				tooltip:AddLine(L["Available Guild Trades:"])
				for i, v in pairs(nameIndex) do
					tooltip:AddLine( BTS(v) )
				end
			end
		end
	end
end
