local rev = tonumber(("$Revision: 180 $"):match("(%d+)")) or 0
if rev > GuildCraft.version then GuildCraft.version = rev end

local D
do
	function D(...)
		local str
		local arg = select(1, ...) or ""
		if string.find(arg, "%%") then
			str = (select(1, ...)):format(select(2,...))
		else
			str = string.join(", ", tostringall(...))
			str:gsub(":,", ":")
		end
		if (not GuildCraft ) or (not GuildCraft.db.global.debug.outofguild) then
			return str
		end

		ChatFrame1:AddMessage("|cff33FF66GC~WotLK-OOG:|r: "..str)
	end
end

local AddonParent = LibStub("AceAddon-3.0"):GetAddon("GuildCraft")
local module = AddonParent:NewModule("Non-Guild-Comms") --Get Toys  
module.rev = rev
local db, TradeSkillScanner, DBO

local L = LibStub("AceLocale-3.0"):GetLocale("GuildCraft")
--local L = AddonParent.L

function module:OnInitialize()
	
end

local function noop() end
function module:GetModuleOptions()
	local t = {
		name = L["Out of Guild"], type = "group", order = 5, handler = module,
		args = {
			getFromPlayer = {
				name = L["Request Data from Player:"], type = "input", order = 1,
				get = noop,
				set = "Get_P_Data",
			},
			breaker2 = {type = "description", name = "\n", order = 2 },
			sendToPlayer = {
				name = L["Send Data to Player:"], type = "input", order = 3,
				get = noop,
				set = "Send_P_Data"
			},
			breaker4 = {type = "description", name = "\n", order = 4 },
			getFromRecentPlayer = {
				name = L["Get Data from Recent Player"], order = 5, type = "select", order = 5,
				values = function(info) return AddonParent.db.profile.quickListOutOfGuild end,
				get = noop,
				set = "Get_P_Data"
			},
			breaker6 = {type = "description", name = "\n", order = 6 },
			sendToRecentPlayer = {
				name = L["Send Data to Recent Player"], order = 5, type = "select", order = 7,
				values = function(info) return AddonParent.db.profile.quickListOutOfGuild end,
				get = noop,
				set = "Send_P_Data"
			},
		},
	}
	return t
end


function module:OnEnable()
	db = AddonParent.db
	TradeSkillScanner = AddonParent:GetModule("TradeSkillScanner")
	DBO = AddonParent:GetModule("DBO", true)
	if not DBO then
		function self:GetModuleOptions()
			return nil
		end
		return
	end
	AddonParent:GetModule("CommsIO"):SoftEmbed(self)
	self:RegisterCommsCall("OOG_SendData")
	self:RegisterCommsCall("OOG_UpdatePlayerData")

	--AddonParent.optionsTable.args.OOG = optionsTable
	self:Print(L["Out of Guild Communications Module Enabled"])
end

function module:OnDisable()
	AddonParent:Print(L["Out of Guild Communications Module |cffff3300Disabled|r"])
end

--"SendToGuild", "SendWhisper", "RegisterCommsCall", "UnregisterCommsCall"--

function module:ReqData(player)		--This is what we call when we are requesting data from some one
	D("Request Data from %s", player or "")
	if player == "" or not player then return end
	self:SendWhisper(player, "OOG_SendData")
end

function module:OOG_SendData(event, dest)		--Part of the dialouge, but we also call this to send people data directly.
	if dest == "" or not dest then return end
	if AddonParent.db.char.shareToGuild then
		D("OOG_Send: %s, -- Sending %s tradeData", event, dest)
		self:SendWhisper(dest, "OOG_UpdatePlayerData", TradeSkillScanner:ScanTradeSkills() )
--		db.profile.quickListOutOfGuild[sender] = sender
	end
end

function module:OOG_UpdatePlayerData(event, sender, ...)	--Really just a wrapper func to grab the name for our short list.
	D("xLink DBO Update Live Data for "..(sender or "?"), ...)	
	DBO:Update_Live_Player_Data("OOG_Synch", sender, ...)	--we grab the name here to verify that 1) they are Online, 2) valid name.
	db.profile.quickListOutOfGuild[sender] = sender
	LibStub("AceConfigRegistry-3.0"):NotifyChange("Guild Craft")
end

function module:Get_P_Data(info, value)
	module:ReqData(value)
end

function module:Send_P_Data(info, value)
	module:OOG_SendData("optTableSend", value)
end

