--ChoicesUI
local rev = tonumber(("$Revision: 199 $"):match("(%d+)")) or 0
if rev > GuildCraft.version then GuildCraft.version = rev end

--Debug and table functions...
local D, clearTable

do
	function D(...)
		local str
		local arg = select(1, ...) or ""
		if string.find(arg, "%%") then
			str = (select(1, ...)):format(select(2,...))
		else
			str = string.join(", ", ...)
			str:gsub(":,", ":")
		end
		if (not GuildCraft ) or (not GuildCraft.db.global.debug.tradeskill) then
			return str
		end
		ChatFrame1:AddMessage("|cff33FF66GC~WotLK-TSS:|r: "..str)
	end
end

do
	function clearTable(t)
		for k, _ in pairs(t) do
			t[k] = nil
		end
		return t
	end
end

local AddonParent = LibStub("AceAddon-3.0"):GetAddon("GuildCraft")
local module = AddonParent:NewModule("TradeSkillScanner", "AceEvent-3.0")
module.rev = rev
local L = LibStub("AceLocale-3.0"):GetLocale("GuildCraft", true)
--local L = AddonParent.L
--local BTS = LibStub("Mini-Bable-TradeSkill")



function module:OnEnable()
	self.links = AddonParent.db.char.links
	--AddonParent.optionsTable.args.ChoiceUI = optionsTable
	self:ScanTradeSkills()
	self:RegisterEvent("TRADE_SKILL_SHOW")
	D("TradeSkillScanner & UI Loaded")
	--self:TestLinks()
end

local tsName = {
	2259,	--Alchemy
	3100,	--Blacksmithing
	2550,	--Cooking
	7411,	--Enchanting
	4036,	--Engineering
	25229,	--Jewelcrafting
	2108,	--Leatherworking
	3908,	--Tailoring
	45357,	--Inscription

}


function module:ScanTradeSkills()
	--D("Scaning Trade Skills")
	local links = self.links
	clearTable(links)
	for i,v in pairs(tsName) do
		local link = select(2, GetSpellLink(v))
		--D("Link", link)
		local val = link and link:match("Htrade:%d+:%d+:%d+:%x+:(A+)")
		val = val and val:gsub(".", function(a) if a == "A" then return ""  end end) == ""
		--D("Val", val)
		if link and not val then
			--D("Adding to table")
			tinsert(links, link)
		end
	end
	--D("Scan TS", unpack(links) )
	return unpack(links)
end

-- GetTradeSkillListLink()
function module:TRADE_SKILL_SHOW(event, ...)
	if IsTradeSkillLinked() then
		D("Trade is linked")
		local _, name =  IsTradeSkillLinked()
		if self.savedLink then
			D("%s's %s", name, self.savedLink)
			if AddonParent.online[name] then
				D("Sending %s's %s to DBO", name, self.savedLink)
				AddonParent:GetModule("DBO"):Update_Live_Player_Data("Trade_Window_Open", name, self.savedLink)
				self.savedLink = nil
			end
		end
	end
end

local old_SetItemRef = SetItemRef

function SetItemRef(link, ...)
	if link:find("trade:") then
		module.savedLink = link
	end
	return old_SetItemRef(link, ...)
end


do
	return
end
do
local spellID = {
	--Alchemy
	2259,	--Apprentice
	3101,	--Journeyman
	3464,	--Expert
	11611,	--Artisan
	28596,	--Master
	51304,	--Grand Master

	--Blacksmithing
	2018,	--Apprentice
	3100,	--Journeyman
	3538,	--Expert
	9785,	--Artisan
	29844,	--Master
	51300,	--Grand Master

	--Cooking
	2550,	--Apprentice
	3102,	--Journeyman
	3413,	--Expert
	18260,	--Artisan
	33359,	--Master
	51296,	--Grand Master

	--Enchanting
	7411,	--Apprentice
	7412,	--Journeyman
	7413,	--Expert
	13920,	--Artisan
	28029,	--Master
	51313,	--Grand Master

	--Engineering
	4036,	--Apprentice
	4037,	--Journeyman
	4038,	--Expert
	12656,	--Artisan
	30350,	--Master
	51306,	--Grand Master

	--Inscription
	45357,	--Apprentice
	45358,	--Journeyman
	45359,	--Expert
	45360,	--Artisan
	45361,	--Master
	45363,	--Grand Master

	--Jewelcrafting
	25229,	--Apprentice
	25230,	--Journeyman
	28894,	--Expert
	28895,	--Artisan
	28897,	--Master
	51311,	--Grand Master

	--Leatherworking
	2108,	--Apprentice
	3104,	--Journeyman
	3811,	--Expert
	10662,	--Artisan
	32549,	--Master
	51302,	--Grand Master

	--Tailoring
	3908,	--Apprentice
	3909,	--Journeyman
	3910,	--Expert
	12180,	--Artisan
	26790,	--Master
	51309,	--Grand Master
}

	function module:TestLinks()
		local test = {}
		for i = 1, #spellID do
			local spell, link = GetSpellLink(spellID[i])
			local val = link and link:match("Htrade:%d+:%d+:%d+:%x+:(A+)")
			val = val and val:gsub(".", function(a) if a == "A" then return ""  end end) == ""
			tinsert(test, {spell = spell, link = link, val = val})
		end
		AddonParent.db.global.test = test	
	end
end
