do
	local rev = tonumber(("$Revision: 209 $"):match("(%d+)")) or 0
	local _,_,objVer, distro = string.find(GuildCraft.version, "(%d+)-([%w-]+)")
	if not objVer then
		_, _, objVer = string.find(GuildCraft.version, "(%d+)")
	end
	if rev > tonumber(objVer) then
		GuildCraft.version = rev
		if distro then
			GuildCraft.version = rev.."-"..distro
		end
	end
end

local D
do
	function D(...)
		local str
		local arg = select(1, ...) or ""
		if string.find(arg, "%%") then
			str = (select(1, ...)):format(select(2,...))
		else
			str = string.join(", ", tostringall(...))
			str:gsub(":,", ":")
		end
		if (not GuildCraft ) or (not GuildCraft.db.global.debug.browser) then
			return str
		end

		ChatFrame1:AddMessage("|cff33FF66GC~WotLK-BUI:|r: "..str)
	end
end

local newtable, deltable
do
	-- Table Pool for recycling tables
	local tablePool = {};
	setmetatable(tablePool, {__mode = "kv"});	-- Weak table

	-- Get a new table
	function newtable()
		local t = next(tablePool) or {};
		tablePool[t] = nil;
		return t;
	end

	-- Delete table and add to table pool
	function deltable(t)
		if (type(t) == "table") then
			for k, v in pairs(t) do
				if (type(v) == "table") then
					deltable(v);	-- child tables get put into the pool
				end
				t[k] = nil;
			end
			setmetatable(t, nil);
			t[true] = true;
			t[true] = nil;
			tablePool[t] = true;
		end
		return nil;
	end
end
-------------------------------------------
local GetLocale, GetSpellInfo, tsort = _G.GetLocale, _G.GetSpellInfo, table.sort
--

local AddonParent = LibStub("AceAddon-3.0"):GetAddon("GuildCraft")
local Module = AddonParent:NewModule("BrowserUI")
Module.rev = rev
local AceGUI = LibStub("AceGUI-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("GuildCraft")
--local L = AddonParent.L
local BTS = LibStub("Mini-Bable-TradeSkill")
local LibGratuity = LibStub("LibGratuity-3.0")
if not BTS then
	local txt = "Guild Craft Not Installed Properly, MiniBTS Missing. Reinstall From curse.com please"
	error(txt)
	message(txt)
	return
end
if not LibGratuity then
	local txt = "Lib Gratuity Not Found - Install dependancy or reinstall package from curse"
	error(txt)
	message(txt)
	return
end

--Global vars that need to always be available to file.
local reqLevlCapture = ITEM_MIN_LEVEL:gsub("%%%a", "(%1+)")
TreeView_Lists = {}
DropDown_List = {}
local currentTradeSkill = nil
local currentSortMethod = nil
local sortByList = {}
local CacheDB, DBO, playerLvl

-- module usual function
function Module:OnInitialize()
	CacheDB = AddonParent.Cache
	DBO = AddonParent:GetModule("DBO", true)
end
function Module:OnEnable()
	if not DBO then
		self.CreateBrowser = nil
		return
	end
	--self:RegisterChatCommand("gcb", self.ToggleBrowser )
--	currentSortMethod = AddonParent.db.profile.displaySortMethod
	self:CreateBrowser()
	GuildCraftTT:SetBackdrop(nil)
	--self:ScheduleTimer("InitScan", 60)
	--playerLvl = UnitLevel("player")
	D("Browser UI Loaded")

end

function Module:OnDisable()
--	AddonParent.db.profile.displaySortMethod = currentSortMethod
end

--Module Utility Functions
local tableStyleSort = function(a,b)
	return a.text < b.text
end
--local sortMethods = {
--	ReqLvl = function(a,b)
--		--if (a.lvl and b.lvl) then
--		--	return a.lvl > b.lvl
--		--end
--		
--		local a_reqLvl, b_reqLvl
--		LibGratuity:SetHyperlink("enchant:"..a.value)
--		a_reqLvl = tonumber(select(3, LibGratuity:Find(reqLevlCapture)) or -1)
--		--D("RLS-A:", (GetSpellInfo(a.value)), GetSpellInfo(a.value) == select(3, string.find( (LibStub("LibGratuity-3.0"):GetLine(1)), "("..(GetSpellInfo(a.value))..")")), a_reqLvl )
--
--		LibGratuity:SetHyperlink("enchant:"..b.value)
--		local b_reqLvl = tonumber(select(3, LibGratuity:Find(reqLevlCapture)) or -1)
--		--D("RLS-B:", (GetSpellInfo(a.value)), GetSpellInfo(a.value) == select(3, string.find( (LibStub("LibGratuity-3.0"):GetLine(1)), "("..(GetSpellInfo(b.value))..")")), b_reqLvl )
--
--		if a_reqLvl == b_reqLvl then
--			--D("a_reqLvl == b_reqLvl", a_reqLvl, b_reqLvl)
--			return a.text < b.text
--		end
--		--a.lvl = a_reqLvl
--		--b.lvl = b_reqLvl
--		--D("a.lvl > b.lvl")
--		return a_reqLvl > b_reqLvl
--	end,
--}

--do
--	for k,_ in pairs(sortMethods) do
--		sortByList[k] = L[k]
--	end
--end

--local function GetSortMethod()
--	return sortMethods[currentSortMethod or AddonParent.db.profile.displaySortMethod]
--end

--function Module:SetSortMethod(method)
--	if sortByList[method] then
--		currentSortMethod = method
--		return true
--	end
--	return false
--end

function Module:Update_TreeView_Lists()
	TreeView_Lists = deltable(TreeView_Lists)
	TreeView_Lists = newtable()
	--D("Update Tree View Lists() ")
	DBO:GetGuildTrade()
	if type(CacheDB) ~= "table" then error("CacheDB not table on Init") end
	for trade, data in pairs(AddonParent.Cache.main) do			--Pairs though the cache
		--D("UTVL: itterate thuogh ", trade)
		local mT = newtable()					--New Table Per-TradeSkill
		for id, _ in pairs(data) do				--pairs over the ID's
			--D("UTVL ID: "..id)
			local t = newtable()				--each craftable get's a table
			if GetLocale() == "enUS" and trade == "Enchanting" then		--Enchanting is HOMO, and dosn't do this in other locales...
				t.text = (GetSpellInfo(id)):gsub("Enchant ","")
			else
				t.text = (GetSpellInfo(id))
			end
			t.value = id						--give it a pass value
			LibGratuity:SetHyperlink("enchant:"..id)
			--D("Add "..(t.text).." to "..trade)
			tinsert(mT, t)						--add craftable to tradeSkill table
		end
		--D("UTVL: Sorting table")
		--tsort(mT, sortMethods.ReqLvl)
		tsort(mT, tableStyleSort)			--sort the table accordingly
		TreeView_Lists[trade] =  mT				--add to master table
		--D("Added", trade, "to Browser Cache")
	end
end
local nub = 0
function Module:Update_DropDown_List()
	--DropDown_List = deltable(DropDown_List)
	--D("Update Drop Down List()" )
	DropDown_List = DropDown_List or newtable()
	local lastNub = nub
	for trade, _ in pairs(DBO:GetGuildTradesList()) do
		if not DropDown_List[trade] then
			DropDown_List[trade] = BTS(trade) or trade
			nub = nub + 1
			--D("Add:", trade, "localized:" , BTS(trade), "to Dropdown List")
		end
	end
	if lastNub ~= nub then
		return true
	end
end

local function OpenHyperlink( owner, link )
	ShowUIPanel(GuildCraftTT);
	if ( not GuildCraftTT:IsShown() ) then
		GuildCraftTT:SetOwner(owner, "ANCHOR_NONE")
		GuildCraftTT:SetPoint("TOPLEFT", owner ,"TOPRIGHT", 20,-70)
	end
	GuildCraftTT:SetHyperlink(link);
end

local function SendHyperlinkToChat( link )
	if ChatFrameEditBox:IsVisible() then
			ChatFrameEditBox:Insert(GetSpellLink(link))
	else
		DEFAULT_CHAT_FRAME:AddMessage(GetSpellLink(link))
	end
end

function Module:InitValues(updateFromDBO)
	--D("InitValues - CurrentTrade:"..(currentTradeSkill and currentTradeSkill or "None"))
	if self:Update_DropDown_List() then
		self:Update_TreeView_Lists()
	end
	--D("InitValues - CurrentTrade: none")
	currentTradeSkill = DropDown_List[currentTradeSkill] and currentTradeSkill or next(DropDown_List)
	if not currentTradeSkill and not next(DropDown_List) then
		--D("InitValues - CurrentTrade: still none")
		return false
	end
	--D("InitValues - CurrentTrade:"..currentTradeSkill)
	return true
end

---Ok..... Make the code look pritty and easy to read....
--This is the AceGUI Code for the browser...

do
	--Locals for all objects as we use them all over the place...
		--status
	local isBrowserShowing
		--Objects
	local browserFrame, tradeSkill_List, treeView_TradeSkills, makersLable, searchBox, refreshBrowser
--	local sortMethodsDropDown
		--Functions
	local browserFrame_OnClose, tradeSkill_List_OnValueChange, treeView_OnSelect, treeView_OnClick
	local searchBox_OnTextChanged, sortMethodsDropDown_OnValueChange, refreshBrowser_OnClick, treeView_OnEnter, treeView_OnLeave
	local tradeSkill_List_OnEnter, tradeSkill_List_OnLeave
	
	--Open-Ze-Bitch()
	
	function Module:CreateBrowser()
		if browserFrame then
			return
		else
		--Module:Update_TreeView_Lists()
		--Module:Update_DropDown_List()
		--Setup Frame , and callbacks....
		browserFrame = AceGUI:Create("Frame")
		browserFrame:SetTitle(L["Guild Craft - Browser"])
		browserFrame:SetLayout("Flow")
		browserFrame:SetCallback("OnClose", browserFrame_OnClose )
		self.frame = browserFrame
		
		--Object1: TradeSkill Drop down box --- this drop down has all the available guild craftables in it..
		tradeSkill_List = AceGUI:Create("Dropdown")
		tradeSkill_List:SetList(DropDown_List)
		tradeSkill_List:SetCallback("OnValueChanged", tradeSkill_List_OnValueChange)
		tradeSkill_List.pullout:SetCallback("OnEnter", tradeSkill_List_OnEnter)
		tradeSkill_List.pullout:SetCallback("OnLeave", tradeSkill_List_OnLeave)


		--Object2: TreeView_TradeSkills ---This is a Tree View Object, tree list shows the craftable items for the selected TradeSkill chosen via "tradeSkill_List"
		treeView_TradeSkills = AceGUI:Create("TreeGroup")
		treeView_TradeSkills.width = "fill"
		treeView_TradeSkills.height = 'fill'
		treeView_TradeSkills:SetLayout("Flow")
		treeView_TradeSkills:SetCallback("OnGroupSelected", treeView_OnSelect)
		treeView_TradeSkills:SetCallback("OnClick", treeView_OnClick)
		treeView_TradeSkills:SetCallback("OnButtonEnter", treeView_OnEnter)
		treeView_TradeSkills:SetCallback("OnButtonLeave", treeView_OnLeave)
		treeView_TradeSkills:SetTreeWidth(263, true)
		treeView_TradeSkills:EnableButtonTooltips(false)

			--Object 2.5: Lable Added to right hand view as a child, this displays who can craft the item, now in Alpha sorted values... yay for tables >.>
			makersLable = AceGUI:Create("Label")
			makersLable:SetText(L["Select a Trade Skill from the List above and the craftables from the left"])
			makersLable.width = "fill"
		
		--Object 3: Search Box
		searchBox = AceGUI:Create("EditBox")
		searchBox:SetLabel(L["Search"])
		searchBox:SetCallback("OnEnterPressed", searchBox_OnTextChanged)
		
		--Object 4: Sort Method Drop down box --- this drop down has all the available sort methods.
--		sortMethodsDropDown = AceGUI:Create("Dropdown")
--		sortMethodsDropDown:SetList(sortByList)
--		sortMethodsDropDown:SetCallback("OnValueChanged", sortMethodsDropDown_OnValueChange)
		
		--Object 5: Browser Refresh Button
		refreshBrowser = AceGUI:Create("Button")
		refreshBrowser:SetText(L["Refresh"])
		refreshBrowser:SetCallback("OnClick", refreshBrowser_OnClick)
		refreshBrowser:SetCallback("OnEnter", refreshBrowser_OnEnter)
		refreshBrowser:SetCallback("OnLeave", refreshBrowser_OnLeave)
		--refreshBrowser.width = "fill"	

		--Make Babies
		browserFrame:AddChild(tradeSkill_List)
		browserFrame:AddChild(searchBox)
--		browserFrame:AddChild(sortMethodsDropDown)
		browserFrame:AddChild(refreshBrowser)		
		browserFrame:AddChild(treeView_TradeSkills)
			treeView_TradeSkills:AddChild(makersLable)
		
		browserFrame:Hide()
		end --end of existance statement
	end		--End of toggle Function
	
	--Functions
	function browserFrame_OnClose(widget, event, ...)
		HideUIPanel( GuildCraftTT )
		browserFrame:Hide()
		isBrowserShowing = false
		--D("Close Browser from browser button or esc")
	end
	
	function tradeSkill_List_OnValueChange(widget, event, value)
		--D("tradeSkill_List_OnValueChange(): "..value)
		currentTradeSkill = value					---Set the Value, Sort it, then set it.
		tsort(TreeView_Lists[currentTradeSkill], tableStyleSort)
		treeView_TradeSkills:SetTree(TreeView_Lists[value])
	end
	
	function treeView_OnSelect(widget, event, value)
		--D("treeView_OnSelect()", value)
		makersLable:SetText( L["Can be crafted by:\n"]..DBO:GetMakersByMain_Alt(currentTradeSkill, value) )
		OpenHyperlink( treeView_TradeSkills.dragger , "enchant:"..value)				
	end
	
	function treeView_OnClick(widget, event, value)
		--D("treeView_OnClick()", value)
		if IsShiftKeyDown() then
			SendHyperlinkToChat(value)		--Add Shift here, as it's not done in SendHyperlinkToChat()
		end
	end
	
	local searchFuncForGratuity = function(a) if a:lower() ~= a:upper() then return "["..a:lower()..a:upper().."]" end end

	local function multiTooltipSearch(...)
		local found = 0		
		local numArgs = select("#", ...)
		for i = 1, numArgs do
			local v = (select(i, ...)):lower():gsub("%a", searchFuncForGratuity )	
			if LibGratuity:Find(v) then
				found = found + 1
			end
		end
		if found == numArgs then 
			return true
		else
			return false
		end
	end

	function searchBox_OnTextChanged(widget, event, value)
		--D("searchBox_OnTextChanged()", value)
		TreeView_Lists[currentTradeSkill] = deltable(TreeView_Lists[currentTradeSkill])
		TreeView_Lists[currentTradeSkill] = newtable()
		local cts_Tree = TreeView_Lists[currentTradeSkill]

		for id, _ in pairs( DBO:GetGuildTrade(currentTradeSkill) ) do
			LibGratuity:SetHyperlink("enchant:"..id)
			if multiTooltipSearch( string.split(" ", value)) then	--LibGratuity:Find(value)
				local t = newtable()
				if GetLocale() == "enUS" and currentTradeSkill == "Enchanting" then		--Enchanting is HOMO, and dosn't do this in other locales...
					--print("Guild Craft: Enchanting Flag Droped")					
					t.text = (GetSpellInfo(id)):gsub("Enchant ","")
				else
					t.text = (GetSpellInfo(id))
				end
				t.value = id						--give it a pass value
				tinsert( cts_Tree,t )
			end
		end
		tsort(cts_Tree, tableStyleSort)
		
		treeView_TradeSkills:SetTree(TreeView_Lists[currentTradeSkill])
		widget.editbox:ClearFocus()
	end
	
--	function sortMethodsDropDown_OnValueChange(widget, event, value)
--		--D("sortMethodsDropDown_OnValueChange()", value)
--		if Module:SetSortMethod(value) then
--			--for craft, data in pairs(TreeView_Lists) do
--				--tsort(data, GetSortMethod())
--			--end
--			tsort(TreeView_Lists[currentTradeSkill], GetSortMethod())		--Changed to just sort the current view, not all. We'll un Pk that later.
--			treeView_TradeSkills:SetTree(TreeView_Lists[currentTradeSkill])
--		end
--	end
	
	function refreshBrowser_OnClick(widget, event, button)
		if IsShiftKeyDown() then		
			DBO:UpdateCacheTable(true)
		else
			DBO:UpdateCacheTable()
		end

		Module:Update_DropDown_List()
		Module:Update_TreeView_Lists()
		tradeSkill_List:SetList(DropDown_List)
		tradeSkill_List:SetValue(currentTradeSkill)
		treeView_TradeSkills:SetTree(TreeView_Lists[currentTradeSkill])
	end

	function treeView_OnEnter(widget, event, value, frame)
		if not tostring(value) then return end
		GameTooltip:SetOwner(this, "ANCHOR_NONE")
	        GameTooltip:SetPoint("RIGHT",frame,"LEFT")
	        GameTooltip:SetHyperlink("enchant:"..value)
	end

	function treeView_OnLeave(widget, event, value, frame)
		GameTooltip:Hide()
	end
	
	function tradeSkill_List_OnEnter(widget, event, ...)
		do
			print("tradeSkill_List_OnEnter", event, ...)
			return
		end
		if not tostring(value) then return end
		GameTooltip:SetOwner(this, "ANCHOR_NONE")
	        GameTooltip:SetPoint("RIGHT",frame,"LEFT")
	        GameTooltip:SetHyperlink("enchant:"..value)
	end

	function tradeSkill_List_OnLeave(widget, event, value, ...)
		do
			print("tradeSkill_List_OnEnter", event, ...)
			return
		end		
		GameTooltip:Hide()
	end

	function Module:ToggleBrowser()
		--D("Toggle Called")
		--Init Inital Values:
		if not Module:InitValues() then
			--D("InitValues Failed")
			browserFrame:Hide()
			isBrowserShowing = false
			self:Print(L["No Trades from Guild available"])
			return
		end
		--D("IntValues Suceeded, setting options")
		tradeSkill_List:SetList(DropDown_List)
		tradeSkill_List:SetValue(currentTradeSkill)
--		sortMethodsDropDown:SetValue(currentSortMethod)
		treeView_TradeSkills:SetTree(TreeView_Lists[currentTradeSkill])

		if isBrowserShowing then
			--D("Browser Open, Closing it")
			isBrowserShowing = false
			browserFrame:Hide()
		elseif not isBrowserShowing then
			--D("Browser Not open, Showing It")
			isBrowserShowing = true
			browserFrame:Show()
		end
	end
	
	--Hook the escape key here....
	local old_CloseSpecialWindows
	if not old_CloseSpecialWindows then
		old_CloseSpecialWindows = CloseSpecialWindows
		CloseSpecialWindows = function()
			local found = old_CloseSpecialWindows()
			if browserFrame and browserFrame.frame:IsVisible() then
				--D("Close Browser from Esc")
				browserFrame:Hide()
				return true
			end
			return found
		end
	end
	
end
